> This is part 1 of 3 of the full documentation (pages 1–100 of 224).
> The content is paginated: fetch every part to see all of it.
> Next part: https://docs.skeddly.com/llms-full.txt/1
> Page index: https://docs.skeddly.com/llms.txt

# Introduction

Welcome to the Skeddly API.

This API is organized as a [REST](http://en.wikipedia.org/wiki/Representational_State_Transfer)ful API:

* URLs are organized into "resources", and
* Appropriate HTTP methods, such as GET, POST, PUT, and DELETE are used.

[Cross-origin resource sharing](http://en.wikipedia.org/wiki/Cross-origin_resource_sharing), or CORS, is fully supported.

POST and PUT requests support [JSON](http://www.json.org/) in the body of the request.

Almost all responses, successes and failures, return [JSON](http://www.json.org/).


# Making Requests

All API requests must be made to the following endpoint:

`https://api.skeddly.com/api/`

All requests must use HTTPS.

Except for a few exceptions, all responses will return JSON data.

By default, some properties of some response models may be omitted from responses. This is for performance reasons. To include those properties, specify them in the request's `include` query parameter.


# Authentication

In order to use the Skeddly API, you require an API key. API keys can be obtained by doing the following:

1. Sign-in to your Skeddly account.
2. On the left navigation panel, click "Developers" then "API Keys".
3. Click the "Create API Key" button to create an API key.

When making HTTPS requests, all requests must include the `Authorization:` header in the following format:

`Authorization: AccessKey <api key>`

You must replace  with your personal API key.

{% tabs %}
{% tab title="HTTP" %}

```http
GET /api/resource HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
```

{% endtab %}

{% tab title="Bash" %}
With shell, you can just pass the correct header with each request

```bash
curl "api_endpoint_here"
  -H "Authorization: AccessKey <api key>"
```

{% endtab %}

{% tab title="Python" %}
Include your access key in the client constructor.

```python
import skeddly
client = skeddly.Client(
    accessKey="<api key>"
)
```

{% endtab %}
{% endtabs %}

Make sure to replace `<api key>` with your API key.


# Clients

## Official

The following clients are officially supported by the Skeddly team.

* .NET - <https://github.com/eleven41/skeddly-sdk-net>
* JavaScript - <https://github.com/eleven41/skeddly-sdk-js>
* Python - <https://github.com/eleven41/skeddly-sdk-python>


# Errors

## Objects

* [Error](/data-types/error-object)

## Extras

* [HTTP Status Codes](/overview/errors/http-status-codes)
* [Error Codes](/overview/errors/error-codes)


# HTTP Status Codes

The Skeddly API uses the following HTTP status codes:

| Status Code | Meaning                                                                  |
| ----------- | ------------------------------------------------------------------------ |
| 200         | Successful operation                                                     |
| 400         | Bad Request -- Change your parameters and try again.                     |
| 401         | Unauthorized -- Your API key is invalid or missing.                      |
| 404         | Not Found -- The specified resource could not be found                   |
| 500         | Internal Server Error -- A problem occurred on our end. Try again later. |
| 503         | Service Unavailable                                                      |


# Error Codes

The Skeddly API will use the following error codes within the JSON to indicate errors in the API operation.

| **Error Code**               | **Meaning**                                                    |
| ---------------------------- | -------------------------------------------------------------- |
| ActionExecutionNotFound      | The specified action execution cannot be not found.            |
| ActionCannotBeDeleted        | The specified action cannot be deleted.                        |
| ActionNotFound               | The specified action cannot be found.                          |
| CredentialInUse              | The specified credential is in use.                            |
| CredentialNotFound           | The specified credential cannot found found.                   |
| ErrorChangingPassword        | An error occurred changing the user password.                  |
| InvalidActionExecutionId     | The specified action execution ID is invalid.                  |
| InvalidActionId              | The specified action ID is invalid.                            |
| InvalidActionVersionId       | The specified action version ID is invalid.                    |
| InvalidCredentialId          | The specified credential ID is invalid.                        |
| InvalidManagedInstanceId     | The specified Managed Instance ID is invalid.                  |
| InvalidParameter             | One of the parameters in the request is invalid.               |
| InvalidRequest               | The request is invalid.                                        |
| InvalidRoleOrAccessDenied    | The specified IAM role is invalid, or it could not be assumed. |
| InvoiceNotFound              | The specified invoice cannot be found.                         |
| ManagedInstanceGroupNotFound | The specified Managed Instance Group cannot be found.          |
| ManagedPolicyNotFound        | The specified managed policy cannot be found.                  |
| ParameterValidationFailed    | One or more parameters failed validation.                      |
| TimeZoneNotFound             | The specified time zone cannot be found.                       |
| UnauthorizedOperation        | The caller is not authorized to execute the command.           |
| UserNotFound                 | The specified user cannot be found.                            |


# Handling Errors

Where ever possible, our SDKs raise/throw exceptions when errors occur. The exception classes include the error message and `errorCode` property returned in the error object.

{% tabs %}
{% tab title="Python" %}

```python
import skeddly

try:
    # Use the Skeddly SDK
    pass
except skeddly.ParameterValidationFailedException as e:
    print("Error Message: " + str(e))
    print("ErrorCode:" + e.errorCode)
    print("modelState: " + str(e.modelState))
except skeddly.SkeddlyWebException as e:
    print("Error Message: " + str(e))
    print("ErrorCode:" + e.errorCode)
```

{% endtab %}

{% tab title="Second Tab" %}

{% endtab %}
{% endtabs %}


# Action Exclusions

## Methods

* [CreateActionExclusion](/resources/action-exclusions/createactionexclusion-method)
* [DeleteActionExclusion](/resources/action-exclusions/deleteactionexclusion-method)
* [GetActionExclusion](/resources/action-exclusions/getactionexclusion-method)
* [ListActionExclusions](/resources/action-exclusions/listactionexclusions-method)
* [ModifyActionExclusion](/resources/action-exclusions/modifyactionexclusion-method)

## Objects

* [ActionExclusion](/data-types/actionexclusion-object)


# CreateActionExclusion Method

## Description

Creates an action exclusion.

## HTTP Request

`POST https://api.skeddly.com/api/ActionExclusions/`

## Body

The body is a JSON structure with the following properties.

### expiryDate

Date and time, in ISO 8601 format, at which the exclusion should expire.

Type: `string`

Required: No

Default Value: No expiry date

### isEnabled

`true` if the exclusion is to be enabled, otherwise `false`.

Type: `boolean`

Required: Yes

### name

Name of the new action exclusion.

Type: `string`

Required: Yes

### processes

List of processes that should be excluded.

Type: Array of `string`

Valid Values:

* `start-resource`
* `stop-resource`

### projectId

ID of the project in which the exclusion is to be created.

Type: `string`

Required: Recommended for future compatability

Default Value: The account's default project.

### resourceIdentificationMethod

Method in which resources will be selected.

Type: `string`

Valid Values:

* `all`
* `by-resource-id`
* `by-resource-tag`

Required: Yes

### resourceIds

IDs of the resources that are to be included in the exclusion. Required when `resourceIdentificationMethod` is `by-resource-id`.

Type: Array of `string`

Required: Conditional

### resourceTagComparison

Comparison to use when identifying resources by resource tag. Required when `resourceIdentificationMethod` is `by-resource-tag`.

Type: [ResourceTagComparison](/data-types/resourcetagcomparison-object-1) object.

### resourceType

Type of resource that the exclusion applies to.

Type: `string`

Required: Yes

### startDate

Date and time, in ISO 8601 format, at which the exclusion should start.

Type: `string`

Required: No

Default Value: Applies immediately

### timeZoneId

ID of the time zone for the exclusion times and dates.

Type: `string`

Required: Yes

## Returns

An [ActionExclusion](/data-types/actionexclusion-object) object.

## &#x20;Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
POST /api/ActionExclusions HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
Content-Type: application/json

{
    "projectId": "proj-00000001",
    
    "name": "My Exclusion",
    "isEnabled": true,
    
    "expiryDate": "2020-05-19T00:00:00Z",
    
    "resourceType": "amazon-ec2-instance",
    
    "resourceIdentificationMethod": "by-resource-id",
    "resourceIds": [
        "i-12345678"
    ],
    
    "processes": [
        "start-resource",
        "stop-resource"
    ]
}
```

{% endtab %}
{% endtabs %}

## Sample Response

```javascript
{
    "actionExclusionId": "excl-00000001",
    "projectId": "proj-00000001",

    "name": "My Exclusion",
    "status": "active",
    "isEnabled": true,

    "createdDate": "2020-05-12T11:36:00Z",
    "lastModifiedDate": "2020-05-12T11:36:00Z",
    "lastModifiedBy": "u-00000001",
    
    "startDate": "2020-05-15T00:00:00Z",
    "expiryDate": "2020-05-19T00:00:00Z",
    "timeZoneId": "Eastern Standard Time",
    
    "processes": [
        "start-resource",
        "stop-resource"
    ],
    
    "resourceType": "amazon-ec2-instance",
    
    "resourceIdentificationMethod": "by-resource-id",
    "resourceIds": [
        "i-12345678"
    ]
}
```


# DeleteActionExclusion Method

## Description

Deletes an action exclusion.

## HTTP Request

`DELETE https://api.skeddly.com/api/ActionExclusions/<id>`

## URL Parameters

### id

ID of the action exclusion.

Type: `string`

Required: Yes

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
DELETE /api/ActionExclusions/excl-00000001 HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl -X DELETE "https://api.skeddly.com/api/ActionExclusions/excl-00000001" \
  -H "Authorization: AccessKey <api key>"
```

{% endtab %}
{% endtabs %}


# GetActionExclusion Method

## Description

Retrieves information for an action exclusion.

## HTTP Request

`GET https://api.skeddly.com/api/ActionExclusions/<id>`

## URL Parameters

### id

ID of the exclusion to retrieve.

Type: `string`

Required: Yes

## Returns

An [ActionExclusion](/data-types/actionexclusion-object) object.

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
GET /api/ActionExclusions/excl-00000001 HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl "https://api.skeddly.com/api/ActionExclusions/excl-00000001" \
  -H "Authorization: AccessKey <api key>"
```

{% endtab %}
{% endtabs %}

## Sample Response

```javascript
{
    "actionExclusionId": "excl-00000001",
    "projectId": "proj-00000001",

    "name": "My Exclusion",
    "status": "active",
    "isEnabled": true,

    "createdDate": "2020-05-12T11:36:00Z",
    "lastModifiedDate": "2020-05-12T11:36:00Z",
    "lastModifiedBy": "u-00000001",
    
    "startDate": "2020-05-15T00:00:00Z",
    "expiryDate": "2020-05-19T00:00:00Z",
    "timeZoneId": "Eastern Standard Time",
    
    "processes": [
        "start-resource",
        "stop-resource"
    ],
    
    "resourceType": "amazon-ec2-instance",
    
    "resourceIdentificationMethod": "by-resource-id",
    "resourceIds": [
        "i-12345678"
    ]
}
```


# ListActionExclusions Method

## Description

Retrieves the list of action exclusions.

## HTTP Request

`GET https://api.skeddly.com/api/ActionExclusions`

## Query Parameters

The following query parameters are accepted.

### filter.projectIds

A comma-separated list of project IDs to include.

Type: `string`

Required: Recommended for future compatability

### filter.resourceType

The resource type to limit the results.

Type: `string`

Value Values:

* `amazon-ec2-instance`
* `amazon-rds-instance`

Required: No

### filter.status

A comma-separated list of statuses.

Type: `string`

Value Values:

* `active-disabled`
* `deleted`
* `expired`

Required: No

## Returns

Array of [ActionExclusion](/data-types/actionexclusion-object) objects.

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
GET /api/ActionExclusions HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl "https://api.skeddly.com/api/ActionExclusions"
  -H "Authorization: AccessKey <api key>"
```

{% endtab %}
{% endtabs %}

## Sample Response

```javascript
[
    {
        "actionExclusionId": "excl-00000001",
        "projectId": "proj-00000001",
    
        "name": "My Exclusion",
        "status": "active",
        "isEnabled": true,
    
        "createdDate": "2020-05-12T11:36:00Z",
        "lastModifiedDate": "2020-05-12T11:36:00Z",
        "lastModifiedBy": "u-00000001",
        
        "startDate": "2020-05-15T00:00:00Z",
        "expiryDate": "2020-05-19T00:00:00Z",
        "timeZoneId": "Eastern Standard Time",
        
        "processes": [
            "start-resource",
            "stop-resource"
        ],
        
        "resourceType": "amazon-ec2-instance",
        
        "resourceIdentificationMethod": "by-resource-id",
        "resourceIds": [
            "i-12345678"
        ]
    }
]
```


# ModifyActionExclusion Method

## Description

Updates an existing action exclusion.

## HTTP Request

`PUT https://api.skeddly.com/api/ActionExclusions/<id>`

## URL Parameters

### Id

ID of the action exclusion.

Type: `string`

Required: Yes

## Body

The body is a JSON structure with the following properties.&#x20;

###

## Returns

An [ActionExclusion](/data-types/actionexclusion-object) object.

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
PUT /api/ActionExclusions/excl-00000001 HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
Content-Type: application/json

{
    "name": "My Exclusion",
    "isEnabled": true,
    
    "expiryDate": "2020-05-19T00:00:00Z",
    
    "resourceType": "amazon-ec2-instance",
    
    "resourceIdentificationMethod": "by-resource-id",
    "resourceIds": [
        "i-12345678"
    ],
    
    "processes": [
        "start-resource",
        "stop-resource"
    ]
}
```

{% endtab %}
{% endtabs %}

## Sample Response

```javascript
{
    "actionExclusionId": "excl-00000001",
    "projectId": "proj-00000001",

    "name": "My Exclusion",
    "status": "active",
    "isEnabled": true,

    "createdDate": "2020-05-12T11:36:00Z",
    "lastModifiedDate": "2020-05-12T11:36:00Z",
    "lastModifiedBy": "u-00000001",
    
    "startDate": "2020-05-15T00:00:00Z",
    "expiryDate": "2020-05-19T00:00:00Z",
    "timeZoneId": "Eastern Standard Time",
    
    "processes": [
        "start-resource",
        "stop-resource"
    ],
    
    "resourceType": "amazon-ec2-instance",
    
    "resourceIdentificationMethod": "by-resource-id",
    "resourceIds": [
        "i-12345678"
    ]
}
```


# Action Executions

## Methods

* [CancelActionExecution](/resources/action-executions/cancelactionexecution-method)
* [GetActionExecution](/resources/action-executions/getactionexecution-method)
* [GetActionExecutionLog](/resources/action-executions/getactionexecutionlog-method)
* [ListActionExecutions](/resources/action-executions/listactionexecutions-method)
* [ListUpcomingActionExecutions](/resources/action-executions/listupcomingactionexecutions-method)

## Objects

* [ActionExecution](/data-types/actionexecution-object)
* [ActionExecutionResult](/data-types/actionexecutionresult-object)
* [UpcomingActionExecution](/data-types/upcomingactionexecution-object)


# CancelActionExecution Method

## Description

Cancels a running action execution. The action will stop and execute any cancelling logic.

## HTTP Request

`PUT https://api.skeddly.com/api/ActionExecutions/<id>/Cancel`

## URL Parameters

### id

The ID of the action execution to cancel.

Type: `string`

Required: Yes

## Returns

An [ActionExecution](/data-types/actionexecution-object) object.

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
PUT /api/ActionExecutions/ae-00000001/Cancel HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl -X PUT "https://api.skeddly.com/api/ActionExecutions/ae-00000001/Cancel"
  -H "Authorization: AccessKey <api key>"
```

{% endtab %}
{% endtabs %}

## Sample Response

```javascript
{
    "actionExecutionId": "ae-00000001",
    "status": "cancelling",
    "startDate": "2016-06-01T12:00:00Z",
    "trigger": "schedule",
    "actionId": "a-00000001",
    "actionVersionId": "av-00000001",
    "actionType": "amazon-start-ec2-instance",
    "actionName": "Start My Instances",
    "timeZoneId": "UTC",
    "credentialId": "cred-00000001"
}
```


# GetActionExecution Method

## Description

Retrieves information about a single action execution.

## HTTP Request

`GET https://api.skeddly.com/api/ActionExecutions/<id>`

## URL Parameters

### id

The ID of the action execution.

Type: `string`

Required: Yes

## Returns

An [ActionExecution](/data-types/actionexecution-object) object.

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
GET /api/ActionExecutions/ae-00000001 HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl "https://api.skeddly.com/api/ActionExecutions/ae-00000001"
  -H "Authorization: AccessKey <api key>"
```

{% endtab %}
{% endtabs %}

## Sample Response

```javascript
{
    "actionExecutionId": "ae-00000001",
    "status": "complete",
    "startDate": "2016-06-01T12:00:00Z",
    "endDate": "2016-06-01T12:03:00Z",
    "result": {
        "code": 0,
        "text": "Execution succeeded"
    },
    "trigger": "schedule",
    "actionId": "a-00000001",
    "actionVersionId": "av-00000001",
    "actionType": "amazon-start-ec2-instance",
    "actionName": "Start My Instances",
    "timeZoneId": "UTC",
    "credentialId": "cred-00000001"
}
```


# GetActionExecutionLog Method

## Description

Returns some or all of the activity log from one action execution.

On success, the response of this method will return the activity log in the response body as plain text. It will not be a JSON body. Headers will be included to help retrieve subsequent portions of the activity log.

## HTTP Request

`GET https://api.skeddly.com/api/ActionExecutions/<id>/Log`

## URL Parameters

### id

The ID of the action execution.

Type: `string`

Required: Yes

## Query Parameters

### marker

Omiting this value will retrieve the beginning of the log. Specifying this parameter will retrieve the next portion of the activity log. Markers specified should be those returned from a previous call.

Type: `string`

Required: No

## Response Headers

Some headers will be included to indicate continuation of the log in a later call.

### X-Skeddly-More

Indicates whether the log is complete or if there is more to retrieve.

Possible values:

* `none` - The log is complete.
* `more` - There is more log to retrieve. The next portion can be retrieved immediately.
* `more-later` - There is no more log to retrieve now, but the action is still executing, so there will be more later. The next portion can be retrieved later. Delay 1 or 2 minutes then try retrieving the next portion.

### X-Skeddly-Next-Marker

Indicates the marker value to include in a subsequent call to retrieve the next portion of the log.

Type: `string`

## Response Body

The response body will contain the activity log in plain text.

## Examples

### Sample 1: Getting the first portion of a log

#### Sample Request

This requests omits the `marker` parameter from the request. This indicates to retrieve the first portion of the log.

{% tabs %}
{% tab title="HTTP" %}

```http
GET /api/ActionExecutions/ae-00000001/Log HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl "https://api.skeddly.com/api/ActionExecutions/ae-00000001/Log"
  -H "Authorization: AccessKey <api key>"
```

{% endtab %}
{% endtabs %}

#### Sample Response

This response specifies `more` to show that more log can be downloaded immediately. The next marker is also included to be used to retrieve the next portion.

```http
Content-Type: plain/text
X-Skeddly-More: more
X-Skeddly-Next-Marker: marker1

D:2020-07-13 12:00 Log Starts
D:2020-07-13 12:00 Line 1
D:2020-07-13 12:00 Line 2
```

### Sample 2: Getting the next portion of a log

#### Sample Request

This requests includes the `marker` parameter from the previous request. This indicates to retrieve the next portion of the log.

{% tabs %}
{% tab title="HTTP" %}

```http
GET /api/ActionExecutions/ae-00000001/Log?marker=marker1 HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl "https://api.skeddly.com/api/ActionExecutions/ae-00000001/Log?marker=marker1"
  -H "Authorization: AccessKey <api key>"
```

{% endtab %}
{% endtabs %}

#### Sample Response

This response specifies `more` to show that there is still more log portions to retrieve. The next marker is included.

```http
Content-Type: plain/text
X-Skeddly-More: more
X-Skeddly-Next-Marker: marker2

D:2020-07-13 12:00 Log Continues
D:2020-07-13 12:00 Line 3
D:2020-07-13 12:00 Line 4
```


# ListActionExecutions Method

## Description

Retrieves the list of action executions.

## HTTP Request

`GET https://api.skeddly.com/api/ActionExecutions`

## Query Parameters

### include

A comma-separated list of extra extra data to include.

Type: `string`

Required: No

### filter.status

Execution status to limit results.

Type: `string`

Valid Values:

* `all`
* `errorsOnly`
* `completedOnly`
* `runningOnly`

Required: No

### filter.actionIds

A comma-separated list of action IDs.

Type: `string`

Required: No

### filter.credentialIds

A comma-separated list of credential IDs.

Type: `string`

Required: No

### filter.actionClasses

A comma-separated list of types of actions for which to include executions.

Valid Values:

* `standard`
* `managedInstances`

### filter.dateComparesTo

Indicator to which the date range references.

Type: `string`

Valid Values:

* `startDate`
* `endDate`

Default: `startDate`

Required: No

### filter.projectIds

A comma-separated list of project IDs to include.

Type: `string`

Required: Recommended for future compatability

### filter.range.inclusiveStart

Start date (inclusive) of the date range, in ISO8601 format.

Type: `string`

Default: Now - 30 days

Required: No

### filter.range.exclusiveEnd

End date (exclusive) of the date range, in ISO8601 format.

Type: `string`

Default: Now

Required: No

## Returns

Array of [ActionExecution](/data-types/actionexecution-object) objects.

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
GET /api/ActionExecutions HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl "https://api.skeddly.com/api/ActionExecutions"
  -H "Authorization: AccessKey <api key>"
```

{% endtab %}
{% endtabs %}

## Sample Response

```javascript
[
  {
    "actionExecutionId": "ae-00000001",
    "status": "complete",
    "startDate": "2016-06-01T12:00:00Z",
    "endDate": "2016-06-01T12:03:00Z",
    "result": {
        "code": 0,
        "text": "Execution succeeded"
    },
    "trigger": "schedule",
    "actionId": "a-00000001",
    "actionVersionId": "av-00000001",
    "actionType": "amazon-start-ec2-instance",
    "actionName": "Start My Instances",
    "timeZoneId": "UTC",
    "credentialId": "cred-00000001"
  }
]
```


# ListUpcomingActionExecutions Method

## Description

Retrieves the list of upcoming action executions.

## HTTP Request

`GET https://api.skeddly.com/api/ActionExecutions/Upcoming`

## Query Parameters

### filter.actionClasses

A comma-separated list of types of actions.

Type: `string`

Valid Values:

* `standard`
* `managedInstances`

Type: `string`

Required: No

### filter.projectIds

A comma-separated list of project IDs to include.

Type: `string`

Required: Recommended for future compatability

## Returns

Array of [UpcomingActionExecution](/data-types/upcomingactionexecution-object) objects.

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
GET /api/ActionExecutions/Upcoming HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl "https://api.skeddly.com/api/ActionExecutions/Upcoming"
  -H "Authorization: AccessKey <api key>"
```

{% endtab %}
{% endtabs %}

## Sample Response

```javascript
[
  {
    "actionId": "a-00000001",
    "actionName": "Start My Instances",
    "actionType": "amazon-start-ec2-instance",
    "actionVersionId": "av-00000001",
    "managedInstanceId": "mi-00000001",
    "startDate": "2016-06-09T12:41:00Z",
    "timeZoneId": "UTC"
  }
]
```


# Actions

## Basics

* &#x20;[Action Types](/resources/actions/action-types)

## Methods

* [CreateAction](/resources/actions/createaction-method)
* [DeleteAction](/resources/actions/deleteaction-method)
* [ExecuteAction](/resources/actions/executeaction-method)
* [GetAction](/resources/actions/getaction-method)
* [ListActions](/resources/actions/listactions-method)
* [ModifyAction](/resources/actions/modifyaction-method)

## Objects

* [Action](/data-types/action-object)
* [ActionSchedule](/data-types/actionschedule-object)
* [DailyScheduleParameters](/data-types/scheduleparameters-object/dailyscheduleparameters-object)
* [HourlyScheduleParameters](/data-types/scheduleparameters-object/hourlyscheduleparameters-object)
* [NoneScheduleParameters](/data-types/scheduleparameters-object/nonescheduleparameters-object)
* [MonthlyScheduleParameters](/data-types/scheduleparameters-object/monthlyscheduleparameters-object)
* [WeekAndDay](/data-types/weekandday-object)
* [WeeklyScheduleParameters](/data-types/scheduleparameters-object/weeklyscheduleparameters-object)


# Action Types

The following list shows the `actionType` code for actions that can be created by the [CreateAction](/resources/actions/createaction-method) method.

When creating an action, specify the action type code in the `actionType` property.

## Amazon Web Services Actions

| Action Type                               | Code                                             | Parameters Object                                                                                                                                   |
| ----------------------------------------- | ------------------------------------------------ | --------------------------------------------------------------------------------------------------------------------------------------------------- |
| Add Security Group Rule                   | amazon-add-security-group-rule                   | [AmazonAddSecurityGroupRuleParameters](/data-types/actionparameters-object/amazonaddsecuritygroupruleparameters-object)                             |
| Apply S3 Bucket Policy                    | amazon-apply-s3-bucket-policy                    | [AmazonApplyS3BucketPolicyParameters](/data-types/actionparameters-object/amazonapplys3bucketpolicyparameters-object)                               |
| Associate Elastic IP Address              | amazon-associate-elastic-ip-address              | [AmazonAssociateElasticIpParameters](/data-types/actionparameters-object/amazonassociateelasticipparameters-object)                                 |
| Attach IAM Role to EC2 Instances          | amazon-attach-iam-role-to-ec2-instances          | [AmazonAttachIamRoleToEc2InstancesParameters](/data-types/actionparameters-object/amazonattachiamroletoec2instancesparameters-object)               |
| Backup EC2 Instance                       | amazon-backup-ec2-instance                       | [AmazonBackupEc2InstanceParameters](/data-types/actionparameters-object/amazonbackupec2instanceparameters-object)                                   |
| Backup EC2 Instances                      | amazon-backup-ec2-instances                      | [AmazonBackupEc2InstancesParameters](/data-types/actionparameters-object/amazonbackupec2instancesparameters-object)                                 |
| Backup MySQL Server                       | amazon-backup-mysql-server                       | [AmazonBackupMySQLServerParameters](/data-types/actionparameters-object/amazonbackupmysqlserverparameters-object)                                   |
| Backup Route 53 Hosted Zone               | amazon-backup-route53-hosted-zone                | [AmazonBackupRoute53HostedZoneParameters](/data-types/actionparameters-object/amazonbackuproute53hostedzoneparameters-object)                       |
| Backup Route 53 Hosted Zones              | amazon-backup-route53-hosted-zones               | [AmazonBackupRoute53HostedZonesParameters](/data-types/actionparameters-object/amazonbackuproute53hostedzonesparameters-object)                     |
| Change DynamoDB Tables                    | amazon-change-dynamodb-tables                    | [AmazonChangeDynamoDbTablesParameters](/data-types/actionparameters-object/amazonchangedynamodbtablesparameters-object)                             |
| Change EBS Volumes                        | amazon-change-ebs-volumes                        | [AmazonChangeEbsVolumesParameters](/data-types/actionparameters-object/amazonchangeebsvolumesparameters-object)                                     |
| Change EC2 Instance Type                  | amazon-change-ec2-instance-type                  | [AmazonChangeEc2InstanceTypeParameters](/data-types/actionparameters-object/amazonchangeec2instancetypeparameters-object)                           |
| Change EC2 Instances                      | amazon-change-ec2-instances                      | [AmazonChangeEc2InstancesParameters](/data-types/actionparameters-object/amazonchangeec2instancesparameters-object)                                 |
| Change RDS Instance Class                 | amazon-change-rds-instance-class                 | [AmazonChangeRdsInstanceClassParameters](/data-types/actionparameters-object/amazonchangerdsinstanceclassparameters-object)                         |
| Check Root Access Keys                    | amazon-check-root-access-keys                    | [AmazonCheckRootAccessKeysParameters](/data-types/actionparameters-object/amazoncheckrootaccesskeysparameters-object)                               |
| CloudFormation Stack Drift Report         | amazon-cloudformation-stack-drift-report         | [AmazonCloudFormationStackDriftReportParameters](/data-types/actionparameters-object/amazoncloudformationstackdriftreportparameters-object)         |
| Copy AMI Images                           | amazon-copy-ami-images                           | [AmazonCopyAmiImagesParameters](/data-types/actionparameters-object/amazoncopyamiimagesparameters-object)                                           |
| Copy EBS Snapshots                        | amazon-copy-ebs-snapshots                        | [AmazonCopyEbsSnapshotsParameters](/data-types/actionparameters-object/amazoncopyebssnapshotsparameters-object)                                     |
| Copy EBS Volume                           | amazon-copy-ebs-volume                           | [AmazonCopyEbsVolumeParameters](/data-types/actionparameters-object/amazoncopyebsvolumeparameters-object)                                           |
| Copy EC2 Instance                         | amazon-copy-ec2-instance                         | [AmazonCopyEc2InstanceParameters](/data-types/actionparameters-object/amazoncopyec2instanceparameters-object)                                       |
| Copy RDS Snapshots                        | amazon-copy-rds-snapshots                        | [AmazonCopyRdsSnapshotsParameters](/data-types/actionparameters-object/amazoncopyrdssnapshotsparameters-object)                                     |
| Copy S3 Objects                           | amazon-copy-s3-objects                           | [AmazonCopyS3ObjectsParameters](/data-types/actionparameters-object/amazoncopys3objectsparameters-object)                                           |
| Create AMI Image                          | amazon-create-ami-image                          | [AmazonCreateAmiImageParameters](/data-types/actionparameters-object/amazoncreateamiimageparameters-object)                                         |
| Create AMI Images                         | amazon-create-ami-images                         | [AmazonCreateAmiImagesParameters](/data-types/actionparameters-object/amazoncreateamiimagesparameters-object)                                       |
| Create CloudFormation Stack               | amazon-create-cloudformation-stack               | [AmazonCreateCloudFormationStackParameters](/data-types/actionparameters-object/createcloudformationstackparameters-object)                         |
| Create CloudTrail Trails                  | amazon-create-cloudtrail-trails                  | [AmazonCreateCloudTrailTrailsParameters](/data-types/actionparameters-object/amazoncreatecloudtrailtrailsparameters-object)                         |
| Create Directory Service Snapshots        | amazon-create-directory-service-snapshots        | [AmazonCreateDirectoryServiceSnapshotsParameters](/data-types/actionparameters-object/amazoncreatedirectoryservicesnapshotsparameters-object)       |
| Create DynamoDB Backups                   | amazon-create-dynamodb-backups                   | [AmazonCreateDynamoDbBackupsParameters](/data-types/actionparameters-object/amazoncreatedynamodbbackupsparameters-object)                           |
| Create EBS Snapshot                       | amazon-create-ebs-snapshot                       | [AmazonCreateEbsSnapshotParameters](/data-types/actionparameters-object/amazoncreateebssnapshotparameters-object)                                   |
| Create EBS Snapshots                      | amazon-create-ebs-snapshots                      | [AmazonCreateEbsSnapshotsParameters](/data-types/actionparameters-object/amazoncreateebssnapshotsparameters-object)                                 |
| Create ElastiCache Cluster                | amazon-create-elasticache-cluster                | [AmazonCreateElastiCacheClusterParameters](/data-types/actionparameters-object/amazoncreateelasticacheclusterparameters-object)                     |
| Create ElastiCache ReadReplica            | amazon-create-elasticache-read-replica           | [AmazonCreateElastiCacheReadReplicaParameters](/data-types/actionparameters-object/amazoncreateelasticachereadreplicaparameters-object)             |
| Create ElastiCache Snapshots              | amazon-create-elasticache-snapshots              | [AmazonCreateElastiCacheSnapshotsParameters](/data-types/actionparameters-object/amazoncreateelasticachesnapshotsparameters-object)                 |
| Create Lightsail Instances from Snapshots | amazon-create-lightsail-instances-from-snapshots | [AmazonCreateLightsailInstancesFromSnapshotsParameters](/data-types/actionparameters-object/createlightsailinstancesfromsnapshotsparameters-object) |
| Create Lightsail Instance Snapshots       | amazon-create-lightsail-instance-snapshots       | [AmazonCreateLightsailInstanceSnapshotsParameters](/data-types/actionparameters-object/amazoncreatelightsailinstancesnapshotsparameters-object)     |
| Create RDS Read Replica                   | amazon-create-rds-read-replica                   | [AmazonCreateRdsReadReplicaParameters](/data-types/actionparameters-object/amazoncreaterdsreadreplicaparameters-object)                             |
| Create RDS Snapshot                       | amazon-create-rds-snapshot                       | [AmazonCreateRdsSnapshotParameters](/data-types/actionparameters-object/amazoncreaterdssnapshotparameters-object)                                   |
| Create RDS Snapshots                      | amazon-create-rds-snapshots                      | [AmazonCreateRdsSnapshotsParameters](/data-types/actionparameters-object/amazoncreaterdssnapshotsparameters-object)                                 |
| Create Redshift Snapshot                  | amazon-create-redshift-snapshot                  | [AmazonCreateRedshiftSnapshotParameters](/data-types/actionparameters-object/amazoncreateredshiftsnapshotparameters-object)                         |
| Delete EBS Snapshots                      | amazon-delete-ebs-snapshots                      | [AmazonDeleteEbsSnapshotsParameters](/data-types/actionparameters-object/amazondeleteebssnapshotsparameters-object)                                 |
| Delete EBS Volumes                        | amazon-delete-ebs-volumes                        | [AmazonDeleteEbsVolumesParameters](/data-types/actionparameters-object/amazondeleteebsvolumesparameters-object)                                     |
| Delete RDS Snapshots                      | amazon-delete-rds-snapshots                      | [AmazonDeleteRdsSnapshotsParameters](/data-types/actionparameters-object/amazondeleterdssnapshotsparameters-object)                                 |
| Deregister AMI Images                     | amazon-deregister-ami-images                     | [AmazonDeregisterAmiImagesParameters](/data-types/actionparameters-object/amazonderegisteramiimagesparameters-object)                               |
| Disable Unused IAM Access Keys            | amazon-disable-unused-iam-access-keys            | [AmazonDisableUnusedIamAccessKeysParameters](/data-types/actionparameters-object/amazondisableunusediamaccesskeysparameters-object)                 |
| Export DynamoDB Tables                    | amazon-export-dynamodb-tables                    | [AmazonExportDynamoDbTablesParameters](/data-types/actionparameters-object/amazonexportdynamodbtablesparameters-object)                             |
| Request EC2 Spot Instances                | amazon-request-ec2-spot-instances                | [AmazonRequestEc2SpotInstancesParameters](/data-types/actionparameters-object/amazonrequestec2spotinstancesparameters-object)                       |
| Send SSM Command                          | amazon-send-ssm-command                          | [AmazonSendSsmCommandParameters](/data-types/actionparameters-object/amazonsendssmcommandparameters-object)                                         |
| Start EC2 Instance                        | amazon-start-ec2-instance                        | [AmazonStartEc2InstanceParameters](/data-types/actionparameters-object/amazonstartec2instanceparameters-object)                                     |
| Start EC2 Instances                       | amazon-start-ec2-instances                       | [AmazonStartEc2InstancesParameters](/data-types/actionparameters-object/amazonstartec2instancesparameters-object)                                   |
| Tag EBS Snapshots                         | amazon-tag-ebs-snapshots                         | [AmazonTagEbsSnapshotsParameters](/data-types/actionparameters-object/amazontagebssnapshotsparameters-object)                                       |
| Update Auto Scaling Groups                | amazon-update-auto-scaling-groups                | [AmazonUpdateAutoScalingGroupsParameters](/data-types/actionparameters-object/amazonupdateautoscalinggroupsparameters-object)                       |
| Update ECS Services                       | amazon-update-ecs-services                       | [AmazonUpdateEcsServicesParameters](/data-types/actionparameters-object/amazonupdateecsservicesparameters-object)                                   |

## Google Cloud Platform Actions

| Action Type                    | Code                                  | Parameters Object                                                                                                                     |
| ------------------------------ | ------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------- |
| Resize Managed Instance Groups | google-resize-managed-instance-groups | [GoogleResizeManagedInstanceGroupsParameters](/data-types/actionparameters-object/googleresizemanagedinstancegroupsparameters-object) |
| Start VM Instances             | google-start-vm-instances             | [GoogleStartVmInstancesParameters](/data-types/actionparameters-object/googlestartvminstancesparameters-object)                       |
| Start Cloud SQL Instances      | google-start-cloud-sql-instances      | [GoogleStartCloudSqlInstancesParameters](/data-types/actionparameters-object/googlestartcloudsqlinstancesparameters-object)           |


# CreateAction Method

## Description

Creates a new action.

## HTTP Request

`POST https://api.skeddly.com/api/Actions/`

## Body

The body is a JSON structure with the following properties.

### actionType

Type of action to create.

Type: `string`

Valid Values: One of the codes listed in the [Action Types](/resources/actions/action-types) table.

Required: Yes

### comments

User notes for the action.

Type: `string`

Required: No

### isEnabled

True to indicate that the action is executable. False otherwise.

Type: `boolean`

Required: No

Default: `false`

### isTriggerBySns

True to indicate that the action should be triggerable by an SNS topic.

Type: `boolean`

Required: No

Default: `false`

### name

Name of the action.

Type: `string`

Required: Yes

### parameters

Additional action parameters specific to the action type.

Type: [ActionParameters](/data-types/actionparameters-object) object.

Required: Yes

### projectId

The ID of the project in which to create the action.

Type: `string`

Required: Recommended for future compatability

Default Value: The account's default project.

### schedule

Schedule for the action.

Type: [ActionSchedule](/data-types/actionschedule-object) object

Required: Yes

### tags

Tags for the action.

Type: array of `string`

Required: No

## Returns

An [Action](/data-types/action-object) object.

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
POST /api/Actions/ HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>

{
    "name": "My action",
    "actionType": "amazon-backup-ec2-instances",
    "isEnabled": true,
    "schedule": {
        "scheduleType": "daily",
        "startDate": "2018-02-26",
        "timeOfDay": "12:05:00",
        "endDate": "2018-02-28",
        "timeZoneId": "Eastern Standard Time",
        "parameters": {
            "days": [
                "monday", "friday"
            ]
        }
    },
    "parameters": {    
        "credentialIds": [ "cred-4d1a201c" ],
        "regionNames": [ "us-east-1" ],

        "instanceIdentificationMethod": "all-instances",
        "ConsistencyMethod": "none",
        "Description": "backups-$(DATE)"
    }
}
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl -X POST "https://api.skeddly.com/api/Actions/"
  -H "Authorization: AccessKey <api key>"
  -d name="My action" \
  -d actionType=amazon-backup-ec2-instances \
  -d isEnabled=true \
  -d schedule.scheduleType=daily \
  -d schedule.startDate=2018-02-26 \
  -d schedule.timeOfDay="12:05:00" \
  -d schedule.endDate=2018-02-28 \
  -d schedule.timeZoneId="Eastern Standard Time"\
  -d schedule.parameters.days[]=monday \
  -d schedule.parameters.days[]=friday \
  -d parameters.credentialIds[]=cred-4d1a201c \
  -d parameters.regionNames[]=us-east-1 \
  -d parameters.instanceIdentificationMethod=all-instances \
  -d parameters.ConsistencyMethod=none \
  -d parameters.Description="backups-$(DATE)" \
```

{% endtab %}

{% tab title="Python" %}

```python
import skeddly
client = skeddly.Client()
action = client.create_action(
    actionType = "amazon-start-ec2-instances",
    name = "Start Development Instances",
    isEnabled = True,
    schedule = {
        "scheduleType": "daily",
        "startDate": "2019-01-01",
        "timeOfDay": "08:00:00",
        "timeZoneId": "Eastern Standard Time",
        "parameters": {
            "days": [
                "monday",
                "tuesday",
                "wednesday",
                "thursday",
                "friday"
            ]
        }
    },
    parameters = {
        "CredentialIds": [
            "cred-12345678"
        ],
        
        "instanceIdentificationMethod": "all-instances",
        "isStop": True
    }
)
```

{% endtab %}
{% endtabs %}

## Sample Response

```javascript
{
    "actionId": "a-00000001",
    "actionType": "amazon-backup-ec2-instances",
    "actionVersionId": "av-00000001",
    "isCurrentVersion": true,
    "isEnabled": true,
    "lastModifiedBy": "u-00000001",
    "lastModifiedDate": "2016-06-09T12:21:00Z",
    "name": "My action",
    "nextExecutionDate": "2016-06-10T12:23:00Z",
    "schedule": {
        "scheduleType": "daily",
        "startDate": "2016-06-10",
        "timeOfDay": "12:23:00",
        "timeZoneId": "Eastern Standard Time",
        "parameters": {
            "days": [
                "monday",
                "friday"
            ]
        }
    },
    "parameters": {    
        "credentialIds": [ "cred-4d1a201c" ],
        "regionNames": [ "us-east-1" ],

        "instanceIdentificationMethod": "all-instances",
        "ConsistencyMethod": "none",
        "Description": "backups-$(DATE)"
    }
}
```


# DeleteAction Method

## Description

Deletes an action.

## HTTP Request

`DELETE https://api.skeddly.com/api/Actions/<id>`

## URL Parameters

### id

ID of the action to delete.

Type: `string`

Required: Yes

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
DELETE /api/Actions/a-00000001 HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl -X DELETE "https://api.skeddly.com/api/Actions/a-00000001" \
  -H "Authorization: AccessKey <api key>"
```

{% endtab %}

{% tab title="Python" %}

```python
import skeddly
client = skeddly.Client()
action = client.delete_action("a-12345678")
```

{% endtab %}
{% endtabs %}


# ExecuteAction Method

## Description

Executes an existing action. The action must be enabled.

## HTTP Request

`PUT https://api.skeddly.com/api/Actions/<id>/Execute`

## URL Parameters

### id

The ID of the action.

Type: `string`

Required: Yes

## Returns

An [ActionExecution](/data-types/actionexecution-object) object.

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
PUT /api/Actions/a-00000001/Execute HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl -X PUT "https://api.skeddly.com/api/Actions/a-00000001/Execute"
  -H "Authorization: AccessKey <api key>"
```

{% endtab %}

{% tab title="Python" %}

```python
import skeddly
client = skeddly.Client()
execution = client.execute_action("a-12345678")
```

{% endtab %}
{% endtabs %}

## Sample Response

```javascript
{
    "actionExecutionId": "ae-00000001",
    "status": "running",
    "startDate": "2016-06-01T12:00:00Z",
    "trigger": "user",
    "actionId": "a-00000001",
    "actionVersionId": "av-00000001",
    "actionType": "amazon-start-ec2-instance",
    "actionName": "Start My Instances",
    "timeZoneId": "UTC",
    "credentialId": "cred-00000001"
}
```


# GetAction Method

## Description

Retrieves the latest version of an action, or a specific version of an action.

## HTTP Request

`GET https://api.skeddly.com/api/Actions/<id>`

## URL Parameters

### id

Action ID or Action Version ID of the action to return. When specifying an action ID for `id`, the latest version of the action will be returned. When specifying an action version ID for `id`, the specified version will be returned.

Type: `string`

Required: Yes

## Query Parameters

### include

A comma-separated list of extra data to include

Type: `string`

Valid Values:

* `displayData`
* `lastExecution`
* `parameters`

Required: No

## Returns

An [Action](/data-types/action-object) object.

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
GET /api/Actions/a-00000001 HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl "https://api.skeddly.com/api/Actions/a-00000001"
  -H "Authorization: AccessKey <api key>"
```

{% endtab %}

{% tab title="Python" %}

```python
import skeddly
client = skeddly.Client()
action = client.get_action("a-12345678")
```

{% endtab %}
{% endtabs %}

## Sample Response

```javascript
{
    "actionId": "a-00000001",
    "actionType": "amazon-start-ec2-instances",
    "actionVersionId": "av-00000001",
    "comments": "Comments about this action",
    "isCurrentVersion": true,
    "isEnabled": true,
    "lastModifiedBy": "u-00000001",
    "lastModifiedDate": "2016-06-09T12:21:00Z",
    "managedInstanceId": "mi-00000001",
    "name": "Start My Instances",
    "nextExecutionDate": "2016-06-10T12:23:00Z",
    "projectId": "proj-00000001",
    "schedule": {
        "scheduleType": "daily",
        "startDate": "2016-06-10",
        "timeOfDay": "12:23:00",
        "timeZoneId": "Eastern Standard Time",
        "parameters": {
            "days": [
                "monday",
                "tuesday",
                "wednesday",
                "thursday",
                "friday"
            ]
        }
    },
    "tags": [
        "cost-reduction"
    ]
}
```


# ListActions Method

## Description

Retrieves the list of actions.

## HTTP Request

`GET https://api.skeddly.com/api/Actions`

## Query Parameters

### include

A comma-separated list of extra data to include.

Type: `string`

Valid Values:

* `displayData`
* `lastExecution`
* `parameters`
* `runningCount`

Required: No

### filter.actionClasses

A comma-separated list of types of actions.

Type: `string`

Value Values:

* `standard`
* `managedInstances`

Required: No

### filter.actionTypes

A comma-separated list of action types.

Type: `string`

Required: No

### filter.credentialIds

A comma-separated list of credential IDs.

Type: `string`

Required: No

### filter.isEnabled

Include action that are enabled or disabled only.

Type: `boolean`

Required: No

### filter.managedInstanceIds

Comma-separated list of Managed Instance IDs.

Type: `string`

Required: No

### filter.projectIds

A comma-separated list of projects to include.

Type: `string`

Default: All projects

Required: No

### filter.regions

Comma-separated list of region system names.

Type: `string`

Required: No

### filter.tags

Comma-separated list of tags.

Type: `string`

Required: No

### filter.tagsRequired

Indicates whether all tags are required. Valid values include: any, all.

Type: `string`

Valid Values:

* `any`
* `all`

Required: No

Default: `any`

## Returns

Array of [Action](/data-types/action-object) objects.

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
GET /api/Actions HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl "https://api.skeddly.com/api/Actions" \
  -H "Authorization: AccessKey <api key>"
```

{% endtab %}

{% tab title="Python" %}

```python
import skeddly
client = skeddly.Client()
actions = client.list_actions()
```

{% endtab %}
{% endtabs %}

## Sample Response

```javascript
[
  {
    "actionId": "a-00000001",
    "actionType": "amazon-start-ec2-instances",
    "actionVersionId": "av-00000001",
    "comments": "Comments about this action",
    "isCurrentVersion": true,
    "isEnabled": true,
    "lastModifiedBy": "u-00000001",
    "lastModifiedDate": "2016-06-09T12:21:00Z",
    "managedInstanceId": "mi-00000001",
    "name": "Start My Instances",
    "nextExecutionDate": "2016-06-10T12:23:00Z",
    "projectId": "proj-00000001",
    "schedule": {
      "scheduleType": "daily",
      "startDate": "2016-06-10",
      "timeOfDay": "12:23:00",
      "timeZoneId": "Eastern Standard Time",
      "parameters": {
        "days": [
          "monday",
          "tuesday",
          "wednesday",
          "thursday",
          "friday"
        ]
      }
    },
    "tags": [
      "cost-reduction"
    ]
  }
]
```


# ModifyAction Method

## Description

Modifies an existing action. The action type cannot be modified for existing actions.

## HTTP Request

`PUT https://api.skeddly.com/api/Actions/{id}`

## URL Parameters

### id

The ID of the action.

Type: `string`

Required: Yes

## Body

The body is a JSON structure with the following properties.

### comments

User notes for the action.

Type: `string`

Required: No

### isEnabled

True to indicate that the action is executable. False otherwise.

Type: `boolean`

Required: No

Default: `false`

### isTriggerBySns

True to indicate that the action should be triggerable by an SNS topic.

Type: `boolean`

Required: No

Default: `false`

### name

Name of the action.

Type: `string`

Required: Yes

### parameters

Additional action parameters specific to the action type.

Type: [ActionParameters](/data-types/actionparameters-object) object.

Required: Yes

### schedule

Schedule for the action.

Type: [ActionSchedule](/data-types/actionschedule-object) object

Required: Yes

### tags

Tags for the action.

Type: array of `string`

Required: No

## Returns

An [Action](/data-types/action-object) object.

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
PUT /api/Actions/a-00000001 HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>

{
    "name": "My action",
    "isEnabled": true,
    "schedule": {
        "scheduleType": "daily",
        "startDate": "2018-02-26",
        "timeOfDay": "12:05:00",
        "endDate": "2018-02-28",
        "timeZoneId": "Eastern Standard Time",
        "parameters": {
            "days": [
                "monday", "friday"
            ]
        }
    },
    "parameters": {    
        "credentialIds": [ "cred-4d1a201c" ],
        "regionNames": [ "us-east-1" ],

        "instanceIdentificationMethod": "all-instances",
        "ConsistencyMethod": "none",
        "Description": "backups-$(DATE)"
    }
}
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl -X PUT "https://api.skeddly.com/api/Actions/a-00000001"
  -H "Authorization: AccessKey <api key>"
  -d name="My action" \
  -d isEnabled=true \
  -d schedule.scheduleType=daily \
  -d schedule.startDate=2018-02-26 \
  -d schedule.timeOfDay="12:05:00" \
  -d schedule.endDate=2018-02-28 \
  -d schedule.timeZoneId="Eastern Standard Time"\
  -d schedule.parameters.days[]=monday \
  -d schedule.parameters.days[]=friday \
  -d parameters.credentialIds[]=cred-4d1a201c \
  -d parameters.regionNames[]=us-east-1 \
  -d parameters.instanceIdentificationMethod=all-instances \
  -d parameters.ConsistencyMethod=none \
  -d parameters.Description="backups-$(DATE)" \
```

{% endtab %}

{% tab title="Python" %}

```python
import skeddly
client = skeddly.Client()
action = client.modify_action(
    "a-12345678",
    name = "Start Development Instances",
    isEnabled = True,
    schedule = {
        "scheduleType": "daily",
        "startDate": "2019-01-01",
        "timeOfDay": "08:00:00",
        "timeZoneId": "Eastern Standard Time",
        "parameters": {
            "days": [
                "monday",
                "tuesday",
                "wednesday",
                "thursday",
                "friday"
            ]
        }
    },
    parameters = {
        "CredentialIds": [
            "cred-12345678"
        ],
        
        "instanceIdentificationMethod": "all-instances",
        "isStop": True
    }
)
```

{% endtab %}
{% endtabs %}

## Sample Response

```javascript
{
    "actionId": "a-00000001",
    "actionType": "amazon-backup-ec2-instances",
    "actionVersionId": "av-00000001",
    "isCurrentVersion": true,
    "isEnabled": true,
    "lastModifiedBy": "u-00000001",
    "lastModifiedDate": "2016-06-09T12:21:00Z",
    "name": "My action",
    "nextExecutionDate": "2016-06-10T12:23:00Z",
    "schedule": {
        "scheduleType": "daily",
        "startDate": "2016-06-10",
        "timeOfDay": "12:23:00",
        "timeZoneId": "Eastern Standard Time",
        "parameters": {
            "days": [
                "monday",
                "friday"
            ]
        }
    },
    "parameters": {    
        "credentialIds": [ "cred-4d1a201c" ],
        "regionNames": [ "us-east-1" ],

        "instanceIdentificationMethod": "all-instances",
        "ConsistencyMethod": "none",
        "Description": "backups-$(DATE)"
    }
}
```


# Credentials

## Methods

* [CreateCredential](/resources/credentials/createcredential-method)
* [CopyCredential](/resources/credentials/createcredential-method-1)
* [DeleteCredential](/resources/credentials/deletecredential-method)
* [GenerateAmazonIamRoleExternalId](/resources/credentials/generateamazoniamroleexternalid-method)
* [GenerateIamPolicy](/resources/credentials/generateiampolicy-method)
* [GetCredential](/resources/credentials/getcredential-method)
* [ListCredentials](/resources/credentials/listcredentials-method)
* [ModifyCredential](/resources/credentials/modifycredential-method)

## Objects

* [Credential](/data-types/credential-object)
* [AmazonIamRoleExternalId](/data-types/amazoniamroleexternalid-object)


# CreateCredential Method

## Description

Registers a cloud-provider credential to be used.

## HTTP Request

`POST https://api.skeddly.com/api/Credentials/`

## Body

The body is a JSON structure with the following properties.

### amazonIamAccessKey

Parameters for the Amazon IAM access key credential. Required when `credentialType` is `amazon-access-key`.

Type: [AmazonIamAccessKeyParameters](/data-types/amazoniamaccesskeyparameters-object) object.

Required: Conditional

### amazonIamRole

Parameters for the Amazon IAM role credential. Required when `credentialType` is `amazon-iam-role`.

Type: [AmazonIamRoleParameters](/data-types/amazoniamroleparameters-object) object.

Required: Conditional

### azureCredential

Parameters for the Azure credential. Required when `credentialType` is `azure-credential`.

Type: [AzureCredentialParameters](/data-types/azurecredentialparameters-object) object.

Required: Conditional

### cloudProviderSubTypeId

Cloud-provider sub-type ID.

Type: `string`

Valid Values:

* `amazon-standard`
* `amazon-govcloud-us`
* `amazon-china`
* `azure-global`
* `google-standard`

Required: Yes

### credentialType

Type of credential being registered.

Type: `string`

Required: Yes

Valid Values:

* `amazon-iam-role`
* `amazon-access-key`
* `azure-credential`
* `google-service-account-key`

### googleServiceAccountKey

Parameters for the Google Cloud Provider service account key credential. Required when `credentialType` is `google-service-account-key`.

Type: [GoogleServiceAccountKeyParameters](/data-types/googleserviceaccountkeyparameters-object) object.

Required: Conditional

### name

Friendly name for the credential.

Type: `string`

Required: Yes

### projectId

The ID of the project in which to create the credential.

Type: `string`

Required: Recommended for future compatability

Default Value: The account's default project.

## Returns

A [Credential](/data-types/credential-object) object.

## &#x20;Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
POST /api/Credentials HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
Content-Type: application/json

{
    "amazonIamRole": {
        "externalId": "skeddly-12345678",
        "roleArn": "arn:aws:iam::123456789012:role/Skeddly"
    },
    "cloudProviderSubTypeId": "amazon-standard",
    "credentialType": "amazon-iam-role",
    
    "name": "My Credential"
}
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl -X POST "https://api.skeddly.com/api/Credentials" \
  -H "Authorization: AccessKey <api key>" \
  -d amazonIamRole.externalId=skeddly-12345678 \
  -d amazonIamRole.roleArn="arn:aws:iam::123456789012:role/Skeddly" \
  -d cloudProviderSubTypeId=amazon-standard \
  -d credentialType=amazon-iam-role \
  -d name="My Credential"
```

{% endtab %}
{% endtabs %}

## Sample Response

```javascript
{
    "amazonIamRole": {
        "roleArn": "arn:aws:iam::123456789012:role/Skeddly",
        "externalId": "skeddly-12345678"
    },
    "cloudProviderSubTypeId": "amazon-standard",
    "createdDate": "2016-06-08T14:42:00Z",
    "credentialId": "cred-00000001",
    "credentialType": "amazon-iam-role",
    "isUsedForSnsNotifications": false,
    "lastModifiedDate": "2016-06-08T14:42:00Z",
    "lastModifiedBy": "u-00000001",
    "name": "My Credential",
    "status": "active"
}
```


# CopyCredential Method

## Description

Copies a cloud-provider credential, within a project, or from one project to another.

## HTTP Request

`POST https://api.skeddly.com/api/Credentials/Copy`

## Body

The body is a JSON structure with the following properties.

### credentialId

Credential ID of the source credential to be copied. This credential can be in the same project or different project from `projectid`.

Type: `string`

Required: Yes

### nameOverride

Name of the new credential. The name of the source credential will be used if omitted.

Type: `string`

Required: No

### projectId

Project ID of the project into which the new copy will be contained.

Type: `string`

Required: Yes

## Returns

A [Credential](/data-types/credential-object) object.

## &#x20;Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
POST /api/Credentials/Copy HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
Content-Type: application/json

{
    "projectId": "proj-12345678",
    "credentialId": "cred-12345678",
    "nameOverride": "Copy of My Credential"
}
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl -X POST "https://api.skeddly.com/api/Credentials/Copy" \
  -H "Authorization: AccessKey <api key>" \
89012:role/Skeddly" \
  -d projectId=proj-12345678 \
  -d credentialId=cred-12345678 \
  -d name="Copy of My Credential"
```

{% endtab %}
{% endtabs %}

## Sample Response

```javascript
{
    "amazonIamRole": {
        "roleArn": "arn:aws:iam::123456789012:role/Skeddly",
        "externalId": "skeddly-12345678"
    },
    "cloudProviderSubTypeId": "amazon-standard",
    "createdDate": "2016-06-08T14:42:00Z",
    "credentialId": "cred-00000001",
    "credentialType": "amazon-iam-role",
    "isUsedForSnsNotifications": false,
    "lastModifiedDate": "2016-06-08T14:42:00Z",
    "lastModifiedBy": "u-00000001",
    "name": "Copy of My Credential",
    "projectId": "proj-12345678",
    "status": "active"
}
```


# DeleteCredential Method

## Description

Deletes a cloud-provider credential.

## HTTP Request

`DELETE https://api.skeddly.com/api/Credentials/<id>`

## URL Parameters

### id

ID of the credential.

Type: `string`

Required: Yes

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
DELETE /api/Credentials/cred-00000001 HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl -X DELETE "https://api.skeddly.com/api/Credentials/cred-00000001" \
  -H "Authorization: AccessKey <api key>"
```

{% endtab %}
{% endtabs %}


# GenerateIamPolicy Method

## Description

Generates an Amazon IAM policy document for an Amazon credential.

## HTTP Request

`GET https://api.skeddly.com/api/Credentials/<id>/IamPolicy`

## URL Parameters

### id

ID of the credential.

Type: `string`

Required: Yes

## Query Parameters

### extras

Comma-separated list of extra data to include.

Type: `string`

Valid Values:

* `my-resources`

Required: No

## Returns

A JSON string containing an IAM policy document.

The IAM policy document is in JSON format, but it is encased in a JSON string.

Deserialize the response body as a JSON string. Then, if required, deserialize the string contents as an Amazon IAM policy document.

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
GET /api/Credentials/cred-00000001/IamPolicy HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl "https://api.skeddly.com/api/Credentials/cred-00000001/IamPolicy" \
  -H "Authorization: AccessKey <api key>"
```

{% endtab %}
{% endtabs %}

## Sample Response

```javascript
"{
    \"Version\": \"2012-10-17\",
    \"Statement\": [
        {
            \"Effect\": \"Allow\",
            \"Action\": [
                \"ec2:DescribeInstances\",
                \"ec2:StartInstances\"
            ],
            \"Resource\": \"*\"
        }
    ]
}"
```


# GenerateAmazonIamRoleExternalId Method

## Description

Generates an external ID to be used for an Amazon IAM Role.

## HTTP Request

`GET https://api.skeddly.com/api/Credentials/GenerateAmazonIamRoleExternalId`

## Query Parameters

### projectId

The ID of the project in which to generate the Amazon external ID.

Type: `string`

Default: Default project

Required: No

## Returns

An [AmazonIamRoleExternalId](/data-types/amazoniamroleexternalid-object) object.

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
GET /api/Credentials/GenerateAmazonIamRoleExternalId HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl "https://api.skeddly.com/api/Credentials/GenerateAmazonIamRoleExternalId" \
  -H "Authorization: AccessKey <api key>"
```

{% endtab %}
{% endtabs %}

## Sample Response

```javascript
{
    "expiryDate": "2016-06-07T20:21:00Z",
    "externalId": "skeddly-12345678"
}
```


# GetCredential Method

## Description

Retrieves information for a credential.

## HTTP Request

`GET https://api.skeddly.com/api/Credentials/<id>`

## URL Parameters

### id

ID of the credential to retrieve.

Type: `string`

Required: Yes

## Query Parameters

### filter.isIncludeDeleted

Indicates whether deleted credentials can be returned.

Type: `boolean`

Required: No

Default: `false`

## Returns

A [Credential](/data-types/credential-object) object.

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
GET /api/Credentials/cred-00000001 HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl "https://api.skeddly.com/api/Credentials/cred-00000001" \
  -H "Authorization: AccessKey <api key>"
```

{% endtab %}
{% endtabs %}

## Sample Response

```javascript
{
    "actionIds": [
        "a-00000001"
    ],
    "amazonIamRole": {
        "roleArn": "arn:aws:iam::123456789012:role/Skeddly",
        "externalId": "skeddly-12345678"
    },
    "cloudProviderSubTypeId": "amazon-standard",
    "createdDate": "2016-06-08T14:42:00Z",
    "credentialId": "cred-00000001",
    "credentialType": "amazon-iam-role",
    "isUsedForSnsNotifications": false,
    "lastModifiedDate": "2016-06-08T14:42:00Z",
    "lastModifiedBy": "u-00000001",
    "managedInstanceIds": [
        "mi-00000001"
    ],
    "name": "My Credential",
    "projectId": "proj-00000001",
    "status": "active"
}
```


# ListCredentials Method

## Description

Retrieves the list of credentials.

## HTTP Request

`GET https://api.skeddly.com/api/Credentials`

## Query Parameters

### filter.credentialIds

A comma-separated list of credential IDs.

Type: `string`

### filter.isIncludeDeleted

Indicates whether to include deleted credentials in the result or not.

Type: `boolean`

Default: false

### filter.projectIds

A comma-separated list of projects to include.

Type: `string`

Default: All projects

Required: No

## Returns

Array of [Credential](/data-types/credential-object) objects.

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
GET /api/Credentials HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl "https://api.skeddly.com/api/Credentials" \
  -H "Authorization: AccessKey <api key>"
```

{% endtab %}

{% tab title="Python" %}

```python
import skeddly
client = skeddly.Client()
credentials = client.list_credentials()
```

{% endtab %}
{% endtabs %}

## Sample Response

```javascript
[
    {
        "actionIds": [
            "a-00000001"
        ],
        "amazonIamRole": {
             "roleArn": "arn:aws:iam::123456789012:role/Skeddly",
             "externalId": "skeddly-12345678"
        },
        "cloudProviderSubTypeId": "amazon-standard",
        "createdDate": "2016-06-08T14:42:00Z",
        "credentialId": "cred-00000001",
        "credentialType": "amazon-iam-role",
        "isUsedForSnsNotifications": false,
        "lastModifiedDate": "2016-06-08T14:42:00Z",
        "lastModifiedBy": "u-00000001",
        "managedInstanceIds": [
            "mi-00000001"
        ],
        "name": "My Credential",
        "projectId": "proj-00000001",
        "status": "active"
    }
]
```


# ModifyCredential Method

## Description

Updates an existing cloud-provider credential.

## HTTP Request

`PUT https://api.skeddly.com/api/Credentials/<id>`

## URL Parameters

### Id

ID of the credential.

Type: `string`

Required: Yes

## Body

The body is a JSON structure with the following properties. All body parameters are optional. Only properties being modified are required.

### amazonIamAccessKey

Parameters for the IAM access key credential. Required when `credentialType` is `amazon-access-key`.

Type: [AmazonIamAccessKeyParameters](/data-types/amazoniamaccesskeyparameters-object) object.

Required: Conditional

### amazonIamRole

Parameters for the IAM role credential. Required when `credentialType` is `amazon-iam-role`.

Type: [AmazonIamRoleParameters](/data-types/amazoniamroleparameters-object) object.

Required: Conditional

### cloudProviderSubTypeId

Cloud-provider sub-type ID.

Type: `string`

Valid Values:

* `amazon-standard`
* `amazon-govcloud-us`
* `amazon-china`
* `google-standard`

Required: Yes

### googleServiceAccountKey

Parameters for the Google Cloud Provider service account key credential. Required when `credentialType` is `google-service-account-key`.

Type: [GoogleServiceAccountKeyParameters](/data-types/googleserviceaccountkeyparameters-object) object.

Required: Conditional

### name

Updated friendly name for the credential.

Type: `string`

Required: No

## Returns

A [Credential](/data-types/credential-object) object.

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
PUT /api/Credentials/cred-00000001 HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
Content-Type: application/json

{
    "amazonIamRole": {
        "externalId": "skeddly-12345678",
        "roleArn": "arn:aws:iam::123456789012:role/Skeddly"
    },
    "cloudProviderSubTypeId": "amazon-standard",
    "name": "My Credential"
}
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl -X PUT "https://api.skeddly.com/api/Credentials/cred-00000001" \
  -H "Authorization: AccessKey <api key>" \
  -d amazonIamRole.externalId=skeddly-12345678 \
  -d amazonIamRole.roleArn="arn:aws:iam::123456789012:role/Skeddly" \
  -d cloudProviderSubTypeId=amazon-standard \
  -d name="My Credential"
```

{% endtab %}
{% endtabs %}

## Sample Response

```javascript
{
    "amazonIamRole": {
        "roleArn": "arn:aws:iam::123456789012:role/Skeddly",
        "externalId": "skeddly-12345678",
    },
    "cloudProviderSubTypeId": "amazon-standard",
    "createdDate": "2016-06-08T14:42:00Z",
    "credentialId": "cred-00000001",
    "credentialType": "amazon-iam-role",
    "isUsedForSnsNotifications": false,
    "lastModifiedDate": "2016-06-08T14:42:00Z",
    "lastModifiedBy": "u-00000001",
    "name": "My Credential",
    "status": "active"
}
```


# Managed Policies

## Methods

* [GetManagedPolicy](/resources/managed-policies/getmanagedpolicy-method)
* [ListManagedPolicy](https://github.com/skeddly/skeddly-api/tree/6d02f9b6e3bedba66e16a6fb9e2503d33556f127/managed-policies/ListManagedPolicy-method.md)

## Objects

* [ManagedPolicy](/data-types/managedpolicy-object)


# GetManagedPolicy Method

## Description

Retrieves information for a single Skeddly managed policy.

## HTTP Request

`GET https://api.skeddly.com/api/ManagedPolicies/<id>`

## URL Parameters

### id

ID of the managed policy to retrieve.

Required: Yes

## Returns

A [ManagedPolicy](/data-types/managedpolicy-object) object.

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
GET /api/ManagedPolicies/full HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl "https://api.skeddly.com/api/ManagedPolicies/full"
  -H "Authorization: AccessKey <api key>"
```

{% endtab %}
{% endtabs %}

## Sample Response

```javascript
{
    "managedPolicyId": "full",
    "name": "Full Access"
}
```


# ListManagedPolicies Method

## Description

Retrieves the list of available Skeddly managed policies.

## HTTP Request

`GET https://api.skeddly.com/api/ManagedPolicies`

## Returns

Array of [ManagedPolicy](/data-types/managedpolicy-object) objects.

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
GET /api/ManagedPolicies HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl "https://api.skeddly.com/api/ManagedPolicies"
  -H "Authorization: AccessKey <api key>"
```

{% endtab %}
{% endtabs %}

## Sample Response

```javascript
[
    {
        "managedPolicyId": "full",
        "name": "Full Access"
    }
]
```


# Managed Services

## Description

Managed Services Plans are comprised of two parts:

* Plans (the schedule and parameters), and
* Selectors (the resources).

First create a plan, then create selectors to add resources to your plan.

## Methods

* [CreateManagedServicesPlan](/resources/managed-services/createmanagedservicesplan-method)
* [CreateManagedServicesSelector](/resources/managed-services/createmanagedservicesselector-method)
* [DeleteManagedServicesPlan](/resources/managed-services/deletemanagedservicesplan-method)
* [DeleteManagedServicesSelector](/resources/managed-services/deletemanagedservicesselector-method)
* [GetManagedServicesPlan](/resources/managed-services/getmanagedservicesplan-method)
* [GetManagedServicesSelector](/resources/managed-services/getmanagedservicesselector-method)
* [ListManagedServicesPlans](/resources/managed-services/listmanagedservicesplans-method)
* [ListManagedServicesSelectors](/resources/managed-services/listmanagedservicesselectors-method)
* [ModifyManagedServicesPlan](/resources/managed-services/modifymanagedservicesplan-method)
* [ModifyManagedServicesSelector](/resources/managed-services/modifymanagedservicesselector-method)

## Objects

* [ManagedServicesGroupIdComparison](/data-types/managedservicesgroupidcomparison-object)
* [ManagedServicesPlan](/data-types/managedservicesplan-object)
* [ManagedServicesPlanParameters](/data-types/managedservicesplanparameters-object)
* [ManagedServicesPlanSchedule](/data-types/managedservicesplanschedule-object)
* [ManagedServicesResourceIdComparison](/data-types/managedservicesresourceidcomparison-object)
* [ManagedServicesResourceTagComparison](/data-types/managedservicesresourcetagcomparison-object)
* [ManagedServicesSelector](/data-types/managedservicesselector-object)
* [ManagedServicesStartStopPlanParameters](/data-types/managedservicesplanparameters-object/managedservicesstartstopplanparameters-object)


# CreateManagedServicesPlan Method

## Description

Creates a Managed Services Plan.

## HTTP Request

`POST https://api.skeddly.com/api/ManagedServices/Plans/`

## Body

The body is a JSON structure with the following properties.

### isEnabled

Indicates whether the plan is enabled.

Type: `bool`

Required: No

Default Value: `false`

### name

Friendly name for the plan.

Type: `string`

Required: Yes

### parameters

Additional parameters for the plan. The object value is dependent on the value of `planType`.

Type: [ManagedServicesPlanParameters](/data-types/managedservicesplanparameters-object) object.

Required: Yes

### planType

Type of plan being registered.

Type: `string`

Required: Yes

Valid Values:

* `backup-plan`
* `start-stop-plan`

### projectId

The ID of the project in which to create the plan.

Type: `string`

Required: Recommended for future compatability

Default Value: The account's default project.

### schedule

Indicates the schedule for the plan

Type: [ManagedServicesPlanSchedule](/data-types/managedservicesplanschedule-object) object.

Required: Yes

## Returns

A [ManagedServicesPlan](/data-types/managedservicesplan-object) object.

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
POST /api/ManagedServices/Plans HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
Content-Type: application/json

{
    "projectId": "proj-00000001",
    "planType": "start-stop-plan",
    "name": "Start Development Environment",
    "isEnabled": true,
    
    "schedule": {
        "scheduleType": "daily",
        "timeOfDay": "08:00:00",
        "timeZoneId": "Eastern Standard Time",
        "parameters": {
            "days": [
                "monday",
                "tuesday",
                "wednesday",
                "thursday",
                "friday"
            ]
        }
    },
    
    "parameters": {
        "startStopMode": "start-stop-combined",
        "stopTimeInSeconds": 43200
    }
}
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl -X POST "https://api.skeddly.com/api/ManagedServices/Plans" \
  -H "Authorization: AccessKey <api key>" \
  -d projectId=proj-00000001 \
  -d planType=start-stop-plan \
  -d name="Start Development Environment" \
  -d isEnabled=true \
  -d schedule.scheduleType=daily \
  -d schedule.timeOfDay="08:00:00" \
  -d schedule.timeZoneId="Eastern Standard Time" \
  -d schedule.parameters.days[0]=monday \
  -d schedule.parameters.days[1]=tuesday \
  -d schedule.parameters.days[2]=wednesday \
  -d schedule.parameters.days[3]=thursday \
  -d schedule.parameters.days[4]=friday \
  -d parameters.startStopMode=start-stop-combined \
  -d parameters.stopTimeInSeconds=43200
```

{% endtab %}
{% endtabs %}

## Sample Response

```javascript
{
    "planId": "plan-00000001",
    "projectId": "proj-00000001",
    "planType": "start-stop-plan",
    "name": "Start Development Environment",
    
    "state": "active",
    "isEnabled": true,
    "isDeleted": false,
    
    "createdDate": "2023-02-13T00:00:00Z",
    "lastModifiedDate": "2023-02-14T00:00:00Z",
    "lastModifiedBy": "u-00000001",
    
    "schedule": {
        "scheduleType": "daily",
        "timeOfDay": "08:00:00",
        "timeZoneId": "Eastern Standard Time",
        "parameters": {
            "days": [
                "monday",
                "tuesday",
                "wednesday",
                "thursday",
                "friday"
            ]
        }
    },
    
    "parameters": {
        "startStopMode": "start-stop-combined",
        "stopTimeInSeconds": 43200
    }
}
```


# CreateManagedServicesSelector Method

## Description

Creates a Managed Services Selector in a plan.

## HTTP Request

`POST https://api.skeddly.com/api/ManagedServices/Plans/<planId>/Selectors`

## URL Parameters

### planId

ID of the Managed Services Plan to that will contain the selector.

Type: `string`

Required: Yes

## Body

The body is a JSON structure with the following properties.

### credentialIds

Identifiers of the credentials used by the selector when matching resources.

Type: Array of `string`

Required: Yes

### groupIdComparisons

Group identifier comparisons used by the selector when matching resources. Only valid if `resourceType` is `azure-virtual-machine`.

Type: Array of [ManagedServicesGroupIdComparison](/data-types/managedservicesgroupidcomparison-object) objects

Required: No

### name

Name of the Managed Services Selector.

Type: `string`

Required: Yes

### regionNames

Regions/locations used by the selector when matching resources.

Type: Array of `string`

Required: No

### resourceIdComparisons

Resource identifier comparisons used by the selector when matching resources.

Type: Array of [ManagedServicesResourceIdComparison](/data-types/managedservicesresourceidcomparison-object) objects

Required: No

### resourceTagComparisons

Resource tag comparisons used by the selector when matching resources.

Type: Array of [ManagedServicesResourceTagComparison](/data-types/managedservicesresourcetagcomparison-object) objects

Required: No

### resourceIds

Resource identifiers used by the selector when matching resources.

Type: Array of `string`

Required: No

### resourceType

Type of resources that will be selected by the selector.

Type: `string`

Valid Values:

* `amazon-ec2-instance`
* `amazon-ebs-volume`
* `amazon-rds-instance`
* `amazon-rds-cluster`
* `amazon-documentdb-cluster`
* `amazon-lightsail-instance`
* `amazon-fsx-filesystem`
* `amazon-appstream-fleet`
* `amazon-redshift-cluster`
* `azure-virtual-machine`
* `google-vm-instance`
* `google-cloudsql-instance`

Required: Yes

### selectorCode

Unique code for the Managed Services Selector.

Type: `string`

Required: No

Default Value: Automatically generated `string`

## Returns

A [ManagedServicesSelector](/data-types/managedservicesselector-object) object.

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
POST /api/ManagedServices/Plans/plan-00000001/Selectors HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
Content-Type: application/json

{
    "name": "Development EC2 Instances",
    
    "credentialIds": [
        "cred-00000001",
        "cred-00000002"
    ],
    
    "resourceType": "amazon-ec2-instance",
    
    "resourceTagComparisons": [
        {
            "tagName": "start-schedule",
            "compareType": "equals",
            "tagValue": "daily-0800"
        }
    ]
}
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl -X POST "https://api.skeddly.com/api/ManagedServices/Plans/plan-00000001/Selectors" \
  -H "Authorization: AccessKey <api key>" \
  -d name="Development EC2 Instances" \
  -d credentialIds[0]=cred-00000001 \
  -d credentialIds[1]=cred-00000002 \
  -d resourceType=amazon-ec2-instances \
  -d resourceTagComparisons[0].tagName=start-schedule \
  -d resourceTagComparisons[0].compareType=equals \
  -d resourceTagComparisons[0].tagValue=daily-0800
```

{% endtab %}
{% endtabs %}

## Sample Response

```javascript
{
    "planId": "plan-00000001",
    "selectorId": "selector-00000001",
    "name": "Development EC2 Instances",
    
    "state": "active",
    "syncState": "ready",
    
    "createdDate": "2023-02-13T00:00:00Z",
    "lastModifiedDate": "2023-02-14T00:00:00Z",
    "lastModifiedBy": "u-00000001",
    
    "selectorCode": "0000000000000000",
    
    "credentialIds": [
        "cred-00000001",
        "cred-00000002"
    ],
    
    "resourceType": "amazon-ec2-instance",
    
    "resourceTagComparisons": [
        {
            "tagName": "start-schedule",
            "compareType": "equals",
            "tagValue": "daily-0800"
        }
    ]
}
```


# DeleteManagedServicesPlan Method

## Description

Deletes a Managed Services Plan.

## HTTP Request

`DELETE https://api.skeddly.com/api/ManagedServices/Plans/<id>`

## URL Parameters

### id

ID of the plan.

Type: `string`

Required: Yes

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
DELETE /api/ManagedServices/Plans/plan-00000001 HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl -X DELETE "https://api.skeddly.com/api/ManagedServices/Plans/plan-00000001" \
  -H "Authorization: AccessKey <api key>"as
```

{% endtab %}
{% endtabs %}


# DeleteManagedServicesSelector Method

## Description

Deletes a Managed Services Selector.

## HTTP Request

`DELETE https://api.skeddly.com/api/ManagedServices/Plans/<planId>/Selectors/<selectorId>`

## URL Parameters

### planId

ID of the Managed Services Plan to that contains the selector to delete.

Type: `string`

Required: Yes

### selectorId

ID of the Managed Services Selector to delete.

Type: `string`

Required: Yes

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
DELETE /api/ManagedServices/Plans/plan-00000001/Selectors/selector-00000001 HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl -X DELETE "https://api.skeddly.com/api/ManagedServices/Plans/plan-00000001/Selectors/selector-00000001" \
  -H "Authorization: AccessKey <api key>"as
```

{% endtab %}
{% endtabs %}


# GetManagedServicesPlan Method

## Description

Retrieves information for a Managed Services Plan.

## HTTP Request

`GET https://api.skeddly.com/api/ManagedServices/Plans/<id>`

## URL Parameters

### id

ID of the Managed Services Plan to retrieve.

Type: `string`

Required: Yes

## Query Parameters

### isIncludeDeleted

Indicates whether deleted plans can be returned.

Type: `boolean`

Required: No

Default: `false`

## Returns

A [ManagedServicesPlan](/data-types/managedservicesplan-object) object.

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
GET /api/ManagedServices/Plans/plan-00000001 HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl "https://api.skeddly.com/api/ManagedServices/Plans/plan-00000001" \
  -H "Authorization: AccessKey <api key>"
```

{% endtab %}
{% endtabs %}

## Sample Response

```javascript
{
    "planId": "plan-00000001",
    "projectId": "proj-00000001",
    "planType": "start-stop-plan",
    "name": "Start Development Environment",
    
    "state": "active",
    "isEnabled": true,
    "isDeleted": false,
    
    "createdDate": "2023-02-13T00:00:00Z",
    "lastModifiedDate": "2023-02-14T00:00:00Z",
    "lastModifiedBy": "u-00000001",
    
    "schedule": {
        "scheduleType": "daily",
        "timeOfDay": "08:00:00",
        "timeZoneId": "Eastern Standard Time",
        "parameters": {
            "days": [
                "monday",
                "tuesday",
                "wednesday",
                "thursday",
                "friday"
            ]
        }
    },
    
    "parameters": {
        "startStopMode": "start-stop-combined",
        "stopTimeInSeconds": 43200
    }
}
```


# GetManagedServicesSelector Method

## Description

Retrieves information for a Managed Services Selector.

## HTTP Request

`GET https://api.skeddly.com/api/ManagedServices/Plans/<planId>/Selectors/<selectorId>`

## URL Parameters

### planId

ID of the Managed Services Plan to that contains the selector to retrieve.

Type: `string`

Required: Yes

### selectorId

ID of the Managed Services Selector to retrieve.

Type: `string`

Required: Yes

## Query Parameters

### isIncludeDeleted

Indicates whether deleted selectors can be returned.

Type: `boolean`

Required: No

Default: `false`

## Returns

A [ManagedServicesSelector](/data-types/managedservicesselector-object) object.

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
GET /api/ManagedServices/Plans/plan-00000001/Selectors/selector-00000001 HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl "https://api.skeddly.com/api/ManagedServices/Plans/plan-00000001/Selectors/selector-00000001" \
  -H "Authorization: AccessKey <api key>"
```

{% endtab %}
{% endtabs %}

## Sample Response

```javascript
{
    "planId": "plan-00000001",
    "selectorId": "selector-00000001",
    "name": "Development EC2 Instances",
    
    "state": "active",
    "syncState": "ready",
    
    "createdDate": "2023-02-13T00:00:00Z",
    "lastModifiedDate": "2023-02-14T00:00:00Z",
    "lastModifiedBy": "u-00000001",
    
    "selectorCode": "0000000000000000",
    
    "credentialIds": [
        "cred-00000001",
        "cred-00000002"
    ],
    "regionNames": null,
    
    "resourceType": "amazon-ec2-instance",
    
    "resourceTagComparisons": [
        {
            "tagName": "start-schedule",
            "compareType": "equals",
            "tagValue": "daily-0800"
        }
    ]
}
```


# ListManagedServicesPlans Method

## Description

Retrieves a list of Managed Services Plans.

## HTTP Request

`GET https://api.skeddly.com/api/ManagedServices/Plans/`

## Query Parameters

### filter.isIncludeDeleted

Indicates whether deleted plans can be returned.

Type: `boolean`

Required: No

Default: `false`

### filter.planIds

A comma-separated list of plan IDs to include.

Type: `string`

Required: No

Default: All plans

### filter.planType

Indicates the type of plans to return.

Type: `string`

Allowed Values:

* `backup-plan`
* `start-stop-plan`

Required: No

Default: All plans

### filter.projectIds

A comma-separated list of project IDs to include.

Type: `string`

Required: No

Default: All projects

## Returns

Array of [ManagedServicesPlan](/data-types/managedservicesplan-object) object.

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
GET /api/ManagedServices/Plans/ HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl "https://api.skeddly.com/api/ManagedServices/Plans/" \
  -H "Authorization: AccessKey <api key>"
```

{% endtab %}
{% endtabs %}

## Sample Response

<pre class="language-javascript"><code class="lang-javascript"><strong>[
</strong><strong>    {
</strong>        "planId": "plan-00000001",
        "projectId": "proj-00000001",
        "planType": "start-stop-plan",
        "name": "Start Development Environment",
        
        "state": "active",
        "isEnabled": true,
        "isDeleted": false,
        
        "createdDate": "2023-02-13T00:00:00Z",
        "lastModifiedDate": "2023-02-14T00:00:00Z",
        "lastModifiedBy": "u-00000001",
        
        "schedule": {
            "scheduleType": "daily",
            "timeOfDay": "08:00:00",
            "timeZoneId": "Eastern Standard Time",
            "parameters": {
                "days": [
                    "monday",
                    "tuesday",
                    "wednesday",
                    "thursday",
                    "friday"
                ]
            }
        },
        
        "parameters": {
            "startStopMode": "start-stop-combined",
            "stopTimeInSeconds": 43200
        }
    }
]
</code></pre>


# ListManagedServicesSelectors Method

## Description

Retrieves a list of Managed Services Selectors from a plan.

## HTTP Request

`GET https://api.skeddly.com/api/ManagedServices/Plans/<planId>/Selectors`

## URL Parameters

### planId

ID of the Managed Services Plan to that contains the selectors to retrieve.

Type: `string`

Required: Yes

## Query Parameters

### filter.isIncludeDeleted

Indicates whether deleted plans can be returned.

Type: `boolean`

Required: No

Default: `false`

## Returns

Array of [ManagedServicesSelector](/data-types/managedservicesselector-object) object.

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
GET /api/ManagedServices/Plans/plan-00000001/Selectors HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl "https://api.skeddly.com/api/ManagedServices/Plans/plan-00000001/Selectors" \
  -H "Authorization: AccessKey <api key>"
```

{% endtab %}
{% endtabs %}

## Sample Response

<pre class="language-javascript"><code class="lang-javascript"><strong>[
</strong><strong>    {
</strong>        "planId": "plan-00000001",
        "selectorId": "selector-00000001",
        "name": "Development EC2 Instances",
        
        "state": "active",
        "syncState": "ready",
        
        "createdDate": "2023-02-13T00:00:00Z",
        "lastModifiedDate": "2023-02-14T00:00:00Z",
        "lastModifiedBy": "u-00000001",
        
        "selectorCode": "0000000000000000",
        
        "credentialIds": [
            "cred-00000001",
            "cred-00000002"
        ],
        "regionNames": null,
        
        "resourceType": "amazon-ec2-instance",
        
        "resourceTagComparisons": [
            {
                "tagName": "start-schedule",
                "compareType": "equals",
                "tagValue": "daily-0800"
            }
        ]
    }
]
</code></pre>


# ModifyManagedServicesPlan Method

## Description

Updates an existing Managed Services Plan.

## HTTP Request

`PUT https://api.skeddly.com/api/ManagedServices/Plans/<id>`

## URL Parameters

### Id

ID of the plan.

Type: `string`

Required: Yes

## Body

The body is a JSON structure with the following properties.

### isEnabled

Indicates whether the plan is enabled.

Type: `bool`

Required: No

Default Value: `false`

### name

Friendly name for the plan.

Type: `string`

Required: Yes

### parameters

Additional parameters for the plan. The object value is dependent on the value of `planType`.

Type: [ManagedServicesPlanParameters](/data-types/managedservicesplanparameters-object) object.

Required: Yes

### schedule

Indicates the schedule for the plan

Type: [ManagedServicesPlanSchedule](/data-types/managedservicesplanschedule-object) object.

Required: Yes

## Returns

A [ManagedServicesPlan](/data-types/managedservicesplan-object) object.

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
PUT /api/ManagedServices/Plans/plan-00000001 HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
Content-Type: application/json

{
    "name": "Start Development Environment",
    "isEnabled": true,
    
    "schedule": {
        "scheduleType": "daily",
        "timeOfDay": "08:00:00",
        "timeZoneId": "Eastern Standard Time",
        "parameters": {
            "days": [
                "monday",
                "tuesday",
                "wednesday",
                "thursday",
                "friday"
            ]
        }
    },
    
    "parameters": {
        "startStopMode": "start-stop-combined",
        "stopTimeInSeconds": 43200
    }
}
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl -X PUT "https://api.skeddly.com/api/ManagedServices/Plans/plan-00000001" \
  -H "Authorization: AccessKey <api key>" \
  -d name="Start Development Environment" \
  -d isEnabled=true \
  -d schedule.scheduleType=daily \
  -d schedule.timeOfDay="08:00:00" \
  -d schedule.timeZoneId="Eastern Standard Time" \
  -d schedule.parameters.days[0]=monday \
  -d schedule.parameters.days[1]=tuesday \
  -d schedule.parameters.days[2]=wednesday \
  -d schedule.parameters.days[3]=thursday \
  -d schedule.parameters.days[4]=friday \
  -d parameters.startStopMode=start-stop-combined \
  -d parameters.stopTimeInSeconds=43200
```

{% endtab %}
{% endtabs %}

## Sample Response

```javascript
{
    "planId": "plan-00000001",
    "projectId": "proj-00000001",
    "planType": "start-stop-plan",
    "name": "Start Development Environment",
    
    "state": "active",
    "isEnabled": true,
    "isDeleted": false,
    
    "createdDate": "2023-02-13T00:00:00Z",
    "lastModifiedDate": "2023-02-14T00:00:00Z",
    "lastModifiedBy": "u-00000001",
    
    "schedule": {
        "scheduleType": "daily",
        "timeOfDay": "08:00:00",
        "timeZoneId": "Eastern Standard Time",
        "parameters": {
            "days": [
                "monday",
                "tuesday",
                "wednesday",
                "thursday",
                "friday"
            ]
        }
    },
    
    "parameters": {
        "startStopMode": "start-stop-combined",
        "stopTimeInSeconds": 43200
    }
}
```


# ModifyManagedServicesSelector Method

## Description

Updates an existing Managed Services Selector.

## HTTP Request

`PUT https://api.skeddly.com/api/ManagedServices/Plans/<planId>/Selectors/<selectorId>`

## URL Parameters

### planId

ID of the Managed Services Plan to that contains the selector to retrieve.

Type: `string`

Required: Yes

### selectorId

ID of the Managed Services Selector to retrieve.

Type: `string`

Required: Yes

## Body

The body is a JSON structure with the following properties.

### credentialIds

Identifiers of the credentials used by the selector when matching resources.

Type: Array of `string`

Required: Yes

### groupIdComparisons

Group identifier comparisons used by the selector when matching resources. Only valid if `resourceType` is `azure-virtual-machine`.

Type: Array of [ManagedServicesGroupIdComparison](/data-types/managedservicesgroupidcomparison-object) objects

Required: No

### name

Name of the Managed Services Selector.

Type: `string`

Required: Yes

### regionNames

Regions/locations used by the selector when matching resources.

Type: Array of `string`

Required: No

### resourceIdComparisons

Resource identifier comparisons used by the selector when matching resources.

Type: Array of [ManagedServicesResourceIdComparison](/data-types/managedservicesresourceidcomparison-object) objects

Required: No

### resourceTagComparisons

Resource tag comparisons used by the selector when matching resources.

Type: Array of [ManagedServicesResourceTagComparison](/data-types/managedservicesresourcetagcomparison-object) objects

Required: No

### resourceIds

Resource identifiers used by the selector when matching resources.

Type: Array of `string`

Required: No

### resourceType

Type of resources that will be selected by the selector.

Type: `string`

Valid Values:

* `amazon-ec2-instance`
* `amazon-ebs-volume`
* `amazon-rds-instance`
* `amazon-rds-cluster`
* `amazon-documentdb-cluster`
* `amazon-lightsail-instance`
* `amazon-fsx-filesystem`
* `amazon-appstream-fleet`
* `amazon-redshift-cluster`
* `azure-virtual-machine`
* `google-vm-instance`
* `google-cloudsql-instance`

Required: Yes

### selectorCode

Unique code for the Managed Services Selector.

Type: `string`

Required: No

Default Value: Automatically generated `string`

## Returns

A [ManagedServicesSelector](/data-types/managedservicesselector-object) object.

## Sample Request

{% tabs %}
{% tab title="HTTP" %}

```http
PUT /api/ManagedServices/Plans/plan-00000001/Selectors/selector-00000001 HTTP/1.1
Host: api.skeddly.com
Authorization: AccessKey <api key>
Content-Type: application/json

{
    "name": "Development EC2 Instances",
    
    "credentialIds": [
        "cred-00000001",
        "cred-00000002"
    ],
    
    "resourceType": "amazon-ec2-instance",
    
    "resourceTagComparisons": [
        {
            "tagName": "start-schedule",
            "compareType": "equals",
            "tagValue": "daily-0800"
        }
    ]
}
```

{% endtab %}

{% tab title="Bash" %}

```bash
curl -X POST "https://api.skeddly.com/api/ManagedServices/Plans/plan-00000001/Selectors/selector-00000001" \
  -H "Authorization: AccessKey <api key>" \
  -d name="Development EC2 Instances" \
  -d credentialIds[0]=cred-00000001 \
  -d credentialIds[1]=cred-00000002 \
  -d resourceType=amazon-ec2-instances \
  -d resourceTagComparisons[0].tagName=start-schedule \
  -d resourceTagComparisons[0].compareType=equals \
[...]
